

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.8.16. TokenTable &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.8.17. TokenTrigram" href="token_trigram.html" />
    <link rel="prev" title="7.8.15. TokenRegexp" href="token_regexp.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/tokenizers/token_table.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="token_trigram.html" title="7.8.17. TokenTrigram"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="token_regexp.html" title="7.8.15. TokenRegexp"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" accesskey="U"><span class="section-number">7.8. </span>トークナイザー</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.16. </span><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="tokentable">
<h1><span class="section-number">7.8.16. </span><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code><a class="headerlink" href="#tokentable" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.8.16.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code> は既知のキーワードのみをトークンとして扱うトークナイザーです。既知のキーワードは <code class="docutils literal notranslate"><span class="pre">TokenTable</span></code> 用のテーブルにキーとして登録されていないといけません。</p>
<p>例えば、クエリーが既知のキーワードと既知でないキーワードを含む場合、検索クエリーには既知のキーワードのみが使われます。(既知でないキーワードは無視されます) コンテンツを既知のキーワードからしか検索できないとも言えます。この特徴のため、新語を使えるようにするにはキーワードを登録するテーブルを継続的にメンテナンスする必要があります。</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.8.16.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code> には必須の引数があります。</p>
<p>テーブルを指定します。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>TokenTable(&quot;table&quot;, TABLE)
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">TABLE</span></code> は <code class="docutils literal notranslate"><span class="pre">--default_tokenizer</span> <span class="pre">'TokenTable(&quot;table&quot;,</span> <span class="pre">TABLE)</span></code> を指定して作成されていないといけません。</p>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.8.16.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code> の使用例です。例えば <code class="docutils literal notranslate"><span class="pre">Raspberry</span> <span class="pre">Pie</span></code> を <code class="docutils literal notranslate"><span class="pre">Pies</span></code> テーブルから検索してみましょう。キーワードのために使われるのは <code class="docutils literal notranslate"><span class="pre">Keywords</span></code> テーブルです。</p>
<p>スキーマ定義とサンプルデータは以下の通りです。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Pies TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Pies name COLUMN_SCALAR Text
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Keywords TABLE_PAT_KEY ShortText --default_tokenizer &#39;TokenTable(&quot;table&quot;, &quot;Keywords&quot;)&#39;
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Keywords index COLUMN_INDEX Pies name
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Keywords
[
{&quot;_key&quot;: &quot;Apple&quot;}
{&quot;_key&quot;: &quot;Orange&quot;}
{&quot;_key&quot;: &quot;Raspberry&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 3]
load --table Pies
[
{&quot;name&quot;: &quot;Apple Pie&quot;},
{&quot;name&quot;: &quot;Orange Pie&quot;}
{&quot;name&quot;: &quot;Raspberry Pie&quot;}
{&quot;name&quot;: &quot;Stargazy Pie&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 4]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">Raspberry</span></code> で <code class="docutils literal notranslate"><span class="pre">Raspberry</span> <span class="pre">Pie</span></code> を検索します。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Pies --match_columns name --query &#39;Raspberry&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;name&quot;,
#           &quot;Text&quot;
#         ]
#       ],
#       [
#         3,
#         &quot;Raspberry Pie&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>期待通りに、上記のクエリーは <code class="docutils literal notranslate"><span class="pre">Raspberry</span> <span class="pre">Pie</span></code> というレコードにマッチします。</p>
<p>次に、<code class="docutils literal notranslate"><span class="pre">Stargazy</span> <span class="pre">Pie</span></code> を <code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">Stargazy</span></code> で検索してみましょう。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Pies --match_columns name --query &#39;Stargazy&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         0
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;name&quot;,
#           &quot;Text&quot;
#         ]
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>上記の例では、<code class="docutils literal notranslate"><span class="pre">Stargazy</span></code> というキーワードは <code class="docutils literal notranslate"><span class="pre">Keywords</span></code> テーブルに登録されていません。そのためマッチしません。</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.8.16.4. </span>参考<a class="headerlink" href="#see-also" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/tokenize.html"><span class="doc">tokenize</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.8.16. <code class="docutils literal notranslate"><span class="pre">TokenTable</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.8.16.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.8.16.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.8.16.3. 使い方</a></li>
<li><a class="reference internal" href="#see-also">7.8.16.4. 参考</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="token_regexp.html"
                        title="前の章へ"><span class="section-number">7.8.15. </span><code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="token_trigram.html"
                        title="次の章へ"><span class="section-number">7.8.17. </span><code class="docutils literal notranslate"><span class="pre">TokenTrigram</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="token_trigram.html" title="7.8.17. TokenTrigram"
             >次へ</a> |</li>
        <li class="right" >
          <a href="token_regexp.html" title="7.8.15. TokenRegexp"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" ><span class="section-number">7.8. </span>トークナイザー</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.16. </span><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>